Global particlesurfaceid
Global particlecount

Type particleparent
	Field id
	Field mesh,surface
	Field vertexindex
End Type

Type particle
	Field parentsurface
	Field x#,y#,z#
	Field scale#
	Field minscale#,maxscale#
	Field scalespeed#
	Field alive
	Field alpha#,alphaspeed#
	Field vertexend
End Type

Global smokeparticleparent


Function initparticlesystem()

	smokeparticleparent = createparticleparent("smoke.png")
	createparticlepool(smokeparticleparent,100,.1,2.5,.01,.005)

End Function


Function createparticleparent(texture$,flag=2)

	particlesurfaceid = particlesurfaceid + 1
	
	p.particleparent = New particleparent
	p\id = particlesurfaceid
	p\mesh = CreateMesh()
	p\surface = CreateSurface(p\mesh)
	
	EntityFX p\mesh,34
	EntityBlend p\mesh,3
	
	tmptexture = LoadTexture(texture$,flag)
	EntityTexture p\mesh,tmptexture
	FreeTexture tmptexture
	
	Return p\surface

End Function


Function createparticlepool(surface,count=100,minscale#=.1,maxscale#=.1,scalespeed#=.01,alphaspeed#=.01)

	For i = 0 To count-1
		createparticle(surface,minscale,maxscale,scalespeed,alphaspeed)
	Next

End Function


Function createparticle(surface,minscale#,maxscale#,scalespeed#,alphaspeed#)

	p.particle = New particle
	p\parentsurface = surface
	p\x = -99999999
	p\y = 0
	p\z = 1
	p\scale = minscale
	p\minscale = minscale
	p\maxscale = maxscale
	p\scalespeed = scalespeed
	p\alive = 0
	p\alpha = 1
	p\alphaspeed = alphaspeed
	
	n.particleparent = findparticleparent(p\parentsurface)
	n\vertexindex = n\vertexindex + 4
	
	p\vertexend = n\vertexindex
	
	AddVertex(p\parentsurface,p\x-(scale/2),p\y+(scale/2),p\z,0,1)
	AddVertex(p\parentsurface,p\x+(scale/2),p\y+(scale/2),p\z,1,1)
	AddVertex(p\parentsurface,p\x-(scale/2),p\y-(scale/2),p\z,0,0)
	AddVertex(p\parentsurface,p\x+(scale/2),p\y-(scale/2),p\z,1,0)
	
	AddTriangle(p\parentsurface,n\vertexindex-2,n\vertexindex-3,n\vertexindex-1)
	AddTriangle(p\parentsurface,n\vertexindex-2,n\vertexindex-4,n\vertexindex-3)

End Function


Function placeparticle(x#,y#,z#,surf)

	If freeparticleexist(surf)
		p.particle = freeparticle(surf)
		
		n.particleparent = findparticleparent(p\parentsurface)
		
		p\x = x
		p\y = y
		p\z = z
		p\alive = 1
		p\alpha = 1
		p\scale = p\minscale
		
		VertexCoords(p\parentsurface,p\vertexend-4,p\x-(p\scale/2),p\y+(p\scale/2),p\z)
		VertexCoords(p\parentsurface,p\vertexend-3,p\x+(p\scale/2),p\y+(p\scale/2),p\z)
		VertexCoords(p\parentsurface,p\vertexend-2,p\x-(p\scale/2),p\y-(p\scale/2),p\z)
		VertexCoords(p\parentsurface,p\vertexend-1,p\x+(p\scale/2),p\y-(p\scale/2),p\z)
		
		particlecount = particlecount + 1
	EndIf

End Function


Function updateparticles()

	For p.particle = Each particle
		If p\alive
			
			p\alpha = p\alpha-p\alphaspeed
			
			VertexColor(p\parentsurface,p\vertexend-4,255,255,255,p\alpha)
			VertexColor(p\parentsurface,p\vertexend-3,255,255,255,p\alpha)
			VertexColor(p\parentsurface,p\vertexend-2,255,255,255,p\alpha)
			VertexColor(p\parentsurface,p\vertexend-1,255,255,255,p\alpha)
			
			If p\scale < p\maxscale
				p\scale = p\scale+p\scalespeed
			EndIf
			
			VertexCoords(p\parentsurface,p\vertexend-4,(p\x-(p\scale/2)),(p\y+(p\scale/2)),p\z)
			VertexCoords(p\parentsurface,p\vertexend-3,(p\x+(p\scale/2)),(p\y+(p\scale/2)),p\z)
			VertexCoords(p\parentsurface,p\vertexend-2,(p\x-(p\scale/2)),(p\y-(p\scale/2)),p\z)
			VertexCoords(p\parentsurface,p\vertexend-1,(p\x+(p\scale/2)),(p\y-(p\scale/2)),p\z)
			
			If p\alpha <= 0 And p\scale >= p\maxscale
				particlecount = particlecount - 1
				p\alive = 0
				p\x = -99999999
				p\y = 0
				p\z = 1
				VertexCoords(p\parentsurface,p\vertexend-4,(p\x-(p\scale/2)),(p\y+(p\scale/2)),p\z)
				VertexCoords(p\parentsurface,p\vertexend-3,(p\x+(p\scale/2)),(p\y+(p\scale/2)),p\z)
				VertexCoords(p\parentsurface,p\vertexend-2,(p\x-(p\scale/2)),(p\y-(p\scale/2)),p\z)
				VertexCoords(p\parentsurface,p\vertexend-1,(p\x+(p\scale/2)),(p\y-(p\scale/2)),p\z)
			EndIf
		EndIf
	Next

End Function


Function freeparticle.particle(surf)

	For p.particle = Each particle
		If p\parentsurface = surf
			If p\alive = 0
				Return p
			EndIf
		EndIf
	Next

End Function


Function freeparticleexist(surf)

	For p.particle = Each particle
		If p\parentsurface = surf
			If p\alive = 0
				Return True
			EndIf
		EndIf
	Next
	
	Return False

End Function


Function findparticleparent.particleparent(surf)

	For p.particleparent = Each particleparent
		If p\surface = surf
			Return p
		EndIf
	Next

End Function